//+------------------------------------------------------------------+
//|                                         pivot points - range.mq4 |
//|                                                           mladen |
//| made at the request of bkennedype                                |
//+------------------------------------------------------------------+
// Modified by bkennedype for breakout

#property copyright "mladen, bkennedype"
#property link      "mladenfx@gmail.com, bkennedype@gmail.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Blue
#property indicator_color7 Red
#property indicator_color8 Blue
#property indicator_style1 STYLE_SOLID
#property indicator_style2 STYLE_SOLID
#property indicator_style3 STYLE_SOLID
#property indicator_style4 STYLE_SOLID
#property indicator_style5 STYLE_SOLID
#property indicator_style6 STYLE_SOLID
#property indicator_style7 STYLE_DOT
#property indicator_style8 STYLE_SOLID
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
//
//
//
//
//

extern string PivotIdentifier       = "BarneyDogBO1";
extern string TimeFrame             = "D1";
extern int    HourShift             = 0;
extern double BuyEntryFib           = 0.5;
extern double BuyTPFib              = 1.0;
extern double BuySLFib              = 0.059;
extern double SellEntryFib          = 0.5;
extern double SellTPFib             = 1.0;
extern double SellSLFib             = 0.059;
extern int    ATRDays               = 22;
extern bool   FixSundays            = true;
extern bool   HideConnections       = true;
extern bool   ShowLabels            = true;
extern bool   ShowPrices            = true;
extern color  LabelsColor           = Black;
extern int    LabelsFontSize        =  8;
extern int    LabelsShiftHorizontal = -5;
extern int    LabelsShiftVertical   = 20;


//
//
//
//
//

double S1Buffer[];
double R1Buffer[];
double S2Buffer[];
double R2Buffer[];
double S3Buffer[];
double R3Buffer[];
double S4Buffer[];
double R4Buffer[];

//
//
//
//
//

string labels[8] = {"Sell @","Buy @","SellTP @","BuyTP @","SellSL @","BuySL @","Open @","R4"};
int    timeFrame;
int    lookupTimeFrame;
string Description;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   lookupTimeFrame = PERIOD_H1;
   timeFrame       = stringToTimeFrame(TimeFrame);
            if (timeFrame<PERIOD_D1)
            {
               HourShift=0;
               lookupTimeFrame = timeFrame;
            }         
            if (timeFrame==PERIOD_W1)
            {
               if (HourShift<0) HourShift -= 24;
               if (HourShift>0) HourShift += 24;
            }
   
   //
   //
   //
   //
   //
   
      SetIndexBuffer(0,S1Buffer); SetIndexLabel(1,Description+labels[0]);
      SetIndexBuffer(1,R1Buffer); SetIndexLabel(2,Description+labels[1]);
      SetIndexBuffer(2,S2Buffer); SetIndexLabel(3,Description+labels[2]);
      SetIndexBuffer(3,R2Buffer); SetIndexLabel(4,Description+labels[3]);
      SetIndexBuffer(4,S3Buffer); SetIndexLabel(5,Description+labels[4]);
      SetIndexBuffer(5,R3Buffer); SetIndexLabel(6,Description+labels[5]);
      SetIndexBuffer(6,S4Buffer); SetIndexLabel(5,Description+labels[6]);
      SetIndexBuffer(7,R4Buffer); SetIndexLabel(6,Description+labels[7]);
   return(0);
}

int deinit()
{
   for (int i = 8; i>0; i--) ObjectDelete(StringConcatenate(PivotIdentifier,"-",i));
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if (Period() >= timeFrame) return(-1);
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
      limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   double S1 = S1Buffer[limit+1];
   double R1 = R1Buffer[limit+1];
   double S2 = S2Buffer[limit+1];
   double R2 = R2Buffer[limit+1];
   double S3 = S3Buffer[limit+1];
   double R3 = R3Buffer[limit+1];
   double S4 = S4Buffer[limit+1];
   double R4 = R4Buffer[limit+1];
   
   for (i=limit; i>=0; i--)
   {
      int x = iBarShift(NULL,timeFrame,Time[i+1]-HourShift*3600,true);
      int y = iBarShift(NULL,timeFrame,Time[i]  -HourShift*3600,true);
      if (x!=y)
      {
         int k = i;
         if (FixSundays && timeFrame==PERIOD_D1)
         {
            while (k<Bars && TimeDayOfWeek(Time[k+1]-HourShift*3600)==0) k++;
         }
         int z = iBarShift(NULL,lookupTimeFrame,Time[k+1]-timeFrame*60-HourShift*3600);
             x = iBarShift(NULL,lookupTimeFrame,Time[k+1]             -HourShift*3600);
               
             //
             //
             //
             //
             //

//double LastHigh  = iHigh (NULL,lookupTimeFrame,iHighest(NULL,lookupTimeFrame,MODE_HIGH,z-x,x));
//double LastLow   = iLow  (NULL,lookupTimeFrame,iLowest( NULL,lookupTimeFrame,MODE_LOW ,z-x,x));
//double LastClose = Close[k+1];
//double LastOpen  = iOpen (NULL,lookupTimeFrame,iHighest(NULL,lookupTimeFrame,MODE_HIGH,z-x,x));
//double Range     = (LastHigh-LastLow);
//double atr = iATR(NULL,PERIOD_D1,ATRDays,i)/2.0;  
             
             //
             //example
             //double var1=0.123456789;
             //Print(DoubleToStr(NormalizeDouble(var1,5),8));
             // output: 0.12346000
             //
             //
             //
               
//R1 = LastClose+atr*BuyEntryFib;
//R2 = LastClose+atr*BuyTPFib;
//R3 = LastClose+atr*BuySLFib;
//             R4 = LastClose+Range*1.1/ 2.0;
//S1 = LastClose-atr*SellEntryFib;
//S2 = LastClose-atr*SellTPFib;
//S3 = LastClose-atr*SellSLFib;
//S4 = LastClose;
             
double LastHigh = iHigh (NULL,lookupTimeFrame,iHighest(NULL,lookupTimeFrame,MODE_HIGH,z-x,x));
double LastLow = iLow (NULL,lookupTimeFrame,iLowest( NULL,lookupTimeFrame,MODE_LOW ,z-x,x));
//double LastClose = Close[k+1];
//double LastOpen = iOpen(NULL,PERIOD_D1,0);
double LastOpen = Open[k];
double Range = (LastHigh-LastLow);
double atr = iATR(NULL,PERIOD_D1,ATRDays,i)/2.0; 

R1 = LastOpen+atr*BuyEntryFib;
R2 = LastOpen+atr*BuyTPFib;
R3 = LastOpen+atr*BuySLFib;
//// R4 = LastClose+Range*1.1/ 2.0;
S1 = LastOpen-atr*SellEntryFib;
S2 = LastOpen-atr*SellTPFib;
S3 = LastOpen-atr*SellSLFib;
S4 = LastOpen;


      }
Comment("\nBreakout Values:","\nBuy @ ",R1,"\nBuyTP @ ",R2,atr,"\nBuySL @ ",R3,"\nSell @ ",S1,"\nSellTP @ ",S2,atr,"\nSellSL @ ",S3,"\nDaily ATR",atr*2);                  
      //
      //
      //
      //
      //
         
      S1Buffer[i]=S1;
      R1Buffer[i]=R1;
      S2Buffer[i]=S2;
      R2Buffer[i]=R2;
      S3Buffer[i]=S3;
      R3Buffer[i]=R3;
      S4Buffer[i]=S4;
      R4Buffer[i]=R4;
   }
   if (ShowLabels || ShowPrices) DisplayLabels();
   if (HideConnections) DoHideConnections(limit);
   return(0);
}



//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int barTime(int a)
{
   if(a<0)
         return(Time[0]+Period()*60*MathAbs(a));
   else  return(Time[a]);   
}

//
//
//
//
//

void DisplayLabels()
{
   ShowLabel(1,S1Buffer,Description+labels[0]);
   ShowLabel(2,R1Buffer,Description+labels[1]);
   ShowLabel(3,S2Buffer,Description+labels[2]);
   ShowLabel(4,R2Buffer,Description+labels[3]);
   ShowLabel(5,S3Buffer,Description+labels[4]);
   ShowLabel(6,R3Buffer,Description+labels[5]);
   ShowLabel(7,S4Buffer,Description+labels[6]);
   ShowLabel(8,R4Buffer,Description+labels[7]);
}
void ShowLabel(string ID, double& forLine[],string label)
{
   string finalLabel = "";
   
   if (ShowLabels) finalLabel = label;
   if (ShowPrices) finalLabel = finalLabel+" "+DoubleToStr(forLine[0],Digits);
         SetLabel(ID,forLine[0],finalLabel);
}

//
//
//
//
//

void SetLabel(string ID,double forLine,string label)
{
   datetime theTime = barTime(LabelsShiftHorizontal);
   string   name    = PivotIdentifier+"-"+ID;
   
   if(ObjectFind(name)==-1) {
      ObjectCreate(name,OBJ_TEXT,0,0,0);
      ObjectSetText(name,label,LabelsFontSize,"Arial",LabelsColor); }
      ObjectMove(name,0,theTime,forLine+LabelsShiftVertical*Point);
   
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

void DoHideConnections(int limit)
{
   
   for (int i=limit;i>=0;i--)
   {
      if (R1Buffer[i] != R1Buffer[i+1]) HideIt(i,R1Buffer);
      if (S1Buffer[i] != S1Buffer[i+1]) HideIt(i,S1Buffer);
      if (R2Buffer[i] != R2Buffer[i+1]) HideIt(i,R2Buffer);
      if (S2Buffer[i] != S2Buffer[i+1]) HideIt(i,S2Buffer);
      if (R3Buffer[i] != R3Buffer[i+1]) HideIt(i,R3Buffer);
      if (S3Buffer[i] != S3Buffer[i+1]) HideIt(i,S3Buffer);
      if (R4Buffer[i] != R4Buffer[i+1]) HideIt(i,R4Buffer);
      if (S4Buffer[i] != S4Buffer[i+1]) HideIt(i,S4Buffer);
   }
}

void HideIt(int i, double& from[])
{
   if ((from[i] != EMPTY_VALUE) && (from[i+1] != EMPTY_VALUE))
        from[i+1] = EMPTY_VALUE;  
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringUpperCase(tfs);
         if (tfs=="M1" || tfs=="1")     { tf=PERIOD_M1;  Description = "";}
         if (tfs=="M5" || tfs=="5")     { tf=PERIOD_M5;  Description = "5 minutes "; }
         if (tfs=="M15"|| tfs=="15")    { tf=PERIOD_M15; Description = "15 minutes ";}
         if (tfs=="M30"|| tfs=="30")    { tf=PERIOD_M30; Description = "half hour "; }
         if (tfs=="H1" || tfs=="60")    { tf=PERIOD_H1;  Description = "hourly ";    }
         if (tfs=="H4" || tfs=="240")   { tf=PERIOD_H4;  Description = "4 hourly ";  }
         if (tfs=="D1" || tfs=="1440")  { tf=PERIOD_D1;  Description = "";     }
         if (tfs=="W1" || tfs=="10080") { tf=PERIOD_W1;  Description = "";    }
         if (tfs=="MN" || tfs=="43200") { tf=PERIOD_MN1; Description = "monthly ";   }
  return(tf);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      length = StringLen(str) - 1;
   int      char;
   
   while(length >= 0)
      {
         char = StringGetChar(s, length);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, length, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, length, char + 224);
         length--;
   }
   return(s);
}